/* Copyright  1997, 1998, Hagiwara Youichi */
/* All rights reserved.                     */

/* Mrand.h : Maximum-length linearly recurring sequence random number */

#ifndef _MRANDH_
#define _MRANDH_

#define MRAND23_MAX 0x7fffff	/* maxmum number of Mrand23() (0x7fffff = 8388607) */
#define MRAND32_MAX 0xffffffff	/* maxmum number of Mrand32() (0xffffffff = 4294967295) */

double gaussrand( double mu, double sigma );	/* returns Gaussian distribution (normal distribution) with expectation = mu, standard deviation = sigma. This uses rand(). (if no memory, return 0) */

long	Mrand23( void );	/* return random number between 0 and MRAND23_MAX (if no memory, return -1) */
int		Msrand23( unsigned int seed );	/* gives new random sequence from seed (default : seed = 1) (if no memory, return NOT 0) */
double	Mgaussrand23( double mu, double sigma );	/* returns Gaussian distribution (normal distribution) with expectation = mu, standard deviation = sigma. This uses Mrand23(). (if no memory, return 0) */

unsigned long	Mrand32( void );	/* return random number between 0 and MRAND32_MAX (if no memory, return 0) */
int				Msrand32( unsigned int seed );	/* gives new random sequence from seed (default : seed = 1) (if no memory, return NOT 0) */
double			Mgaussrand32( double mu, double sigma );	/* returns Gaussian distribution (normal distribution) with expectation = mu, standard deviation = sigma. This uses Mrand32(). (if no memory, return 0) */

#endif