/*** randM Driver by Hagiwara Youichi ***/

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "Mrand.h"

/*** You can set the following parameters. ***/

#define CHI2	/* CHI2 or PI or BIT */
#define CATEGORY 101	/* (CHI2) number of category (freedom = category - 1) */
#define PAR 10000	/* (CHI2)(PI)(BIT) count par PAR */
#define BITNUM 1	/* (BIT) bit number (23 <= BITNUM <= 1) */

/*** This is all. ***/

#if defined( CHI2 )
int main( void )
{
	unsigned long	c, n, chi[CATEGORY] = {0};
	double			chi2;

	printf( "<< randM test : chi^2 >>\n" );

	n = (unsigned long)Msrand23( (unsigned int)time( (time_t *)NULL ) );

	if ( n ) {
		printf( "\n\t== NO MEMORY! ==\n\n" );
		printf( "\a( Please enter [RETURN]key to QUIT. )" );
		fflush( stdout );
		getchar();
		return 0;
	}

	printf( "\tdegree of freedom = %lu, number = %lu\n", (unsigned long)(CATEGORY - 1), (unsigned long)PAR );

	while ( 1 ) {
		chi2 = 0.;

		for ( n = 0; n < PAR; n++ ) {
			c = (unsigned long)(CATEGORY * (double)Mrand23() / (double)(MRAND23_MAX + 1));
			chi[c]++;
		}

		for ( n = 0; n < CATEGORY; n++ )
			chi2 += ((double)(chi[n]) * (double)CATEGORY - (double)PAR) * ((double)(chi[n]) * (double)CATEGORY - (double)PAR);

		chi2 /= (double)CATEGORY * (double)PAR;

		printf( "\nchi^2 = %f\n", chi2 );

		printf( "\n( Please enter [RETURN]key to get next result. )" );
		fflush( stdout );
		getchar();

		for ( n = 0; n < CATEGORY; n++ )
			chi[n] = 0;
	}
}
#elif defined( PI )
int main( void )
{
	unsigned long	n, m;
	double			pi;
	long double		x, y;

	printf( "<< randM test : Pi (ratio of the circumference of the circle to the diameter) >>\n" );

	n = (unsigned long)Msrand23( (unsigned int)time( (time_t *)NULL ) );
	m = 0;

	if ( n ) {
		printf( "\n\t== NO MEMORY! ==\n\n" );
		printf( "\a( Please enter [RETURN]key to QUIT. )" );
		fflush( stdout );
		getchar();
		return 0;
	}

	printf( "number \\ inner = Pi(3.1415926535897932384626433...)\n" );

	while ( 1 ) {
		n++;
		x = (long double)Mrand() / (long double)MRAND23_MAX;
		y = (long double)Mrand() / (long double)MRAND23_MAX;
		if ( x * x + y * y < 1 )
			m++;
		if ( !(n % PAR) ) {
			pi = 4 * (double)m / (double)n;
			printf(	"%lu \\ %lu = %.25f\n", n, m, pi );
		}
	}
}
#elif defined( BIT )
int main( void )
{
	unsigned short	i;
	unsigned long	bit = 1, n;

	printf( "<< randM test : bit sequence >>\n" );

	n = (unsigned long)Msrand23( (unsigned int)time( (time_t *)NULL ) );

	if ( n ) {
		printf( "\n\t== NO MEMORY! ==\n\n" );
		printf( "\a( Please enter [RETURN]key to QUIT. )" );
		fflush( stdout );
		getchar();
		return 0;
	}

	printf( "\tBIT number : %hu\n", (unsigned short)BITNUM );

	bit <<= (BITNUM - 1);

	while ( 1 ) {
		for ( n = 0; n < PAR; ++n )
			switch ( n % 80 ) {
				case 0 :
					printf( "\n" );
				default :
					i = (unsigned short)(((unsigned long)Mrand23() & bit) >> (BITNUM - 1));
					printf( "%hu", i );
					break;
			}
		getchar();
	}
}
#endif